;==========================================================================
; TestIOLib.asm - a program to test the IO asm library
; twl 6 apr 12
;==========================================================================

		.386					;cpu mode
		.model flat				;non segmented memory model
		;
		;declare the routines used out of the library as external to our code
		;
		extern _output:near		;asm lang i/o lib print to console
		extern _input:near		;asm lang i/o lib get console input
		extern _exit:near		;asm lang i/o lib program exit
;--------------------------------------------------------------------------			
		.stack 4096				;defines a 4k stack area
;--------------------------------------------------------------------------

;--------------------------------------------------------------------------			
		.data					;defines program data area
;--------------------------------------------------------------------------
msgHello	byte 0dh, 0ah, "Enter some characters.", 0dh, 0ah
HelloLen	dword ($ - msgHello)	;$ = here -> # bytes in the string above
			
;--------------------------------------------------------------------------			
		.code				;defines program code area
;--------------------------------------------------------------------------

start	PROC						;program entry point

		mov eax, HelloLen			;load the number of characters to print
		mov	ebx, offset msgHello	;load the address of the message
		call _output				;library routine to print the message
			
		call _input					;library routine to get some characters
									;address of input buffer in eax
									;and number of bytes read in ecx
										
		mov ebx, eax				;put the address in ebx
		mov eax, ecx				;put the number of chars to print in eax
		call _output				;print them on the screen
			
		call _exit					;exit the program
			
		ret							;we should actually not reach this point

start	ENDP						;end of main procedure

		END							;end source code
;--------------------------------------------------------------------------
		